/*
 * Playground+ - smess.c
 * smess code v1.3 (by Radiac)
 *    Saved messages for users :)
 *    http://radiac.net/pgplus
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <unistd.h>

#include "include/config.h"
#include "include/player.h"
#include "include/proto.h"

#define MAX_MESSAGE_SIZE 1000

/*
typedef struct smess_data_struct {
	char *source, *target;
	int datetime;
	char *message;
} smess_data;
*/

/* function to create and save a message
 *   take target user and message
 *   create a struct
 *   add it to a file if they're not logged in
 */

void smess(player *p, char *str) {
	char *message, *oldstack, name[MAX_NAME];
	player dummy;
	FILE *fp;

	/* Split the target name and the message */
	message = next_space(str);
	*message++ = '\0';

	/* Check that the target is a logged out player */
	if (find_player_global_quiet(str)) {
		TELLPLAYER(p, " %s is logged in at the moment, smess not sent.\n", str);
		return;
	}

	strcpy(dummy.lower_name, str);
	lower_case(dummy.lower_name);
	dummy.fd = p->fd;
	if (!load_player(&dummy)) {
		return;
	}

	/* Check message exists, thanks mihtjel :) */
	if (strlen(message) == 0) {
		TELLPLAYER(p, " You must provide a message!\n");
		return;
	}

	/* Check message size maximum MAX_MESSAGE_SIZE chars */
	if (strlen(message) > MAX_MESSAGE_SIZE) {
		TELLPLAYER(p, " The message is too long, it can not exceed %d characters.\n", MAX_MESSAGE_SIZE);
		return;
	}

	/* Write out the smess */
	oldstack = stack;
	strcpy(name, str);
	lower_case(name);
	sprintf(stack, "files/smess/%s", name);
	stack = oldstack;
	if ((fp = fopen(stack, "a")) == NULL) {
		TELLPLAYER(p, " Message could not be sent to %s at this time\n", str);
		LOGF("error", " Failed to open smess file for player %s", str);
		stack = oldstack;
		return;
	}
	fprintf(fp, "%s\n%s\n%s\n", p->name, convert_time(time(0)), message);
	fclose(fp);

	/* Report */
	TELLPLAYER(p, " Message sent to %s.\n", str);
}

/* function to display any saved messages
 *   take nothing? or user if you're an admin?
 *   read file for user and display any messages
 */
void smess_read(player *p) {
	char *oldstack, name[MAX_NAME], date[50], message[MAX_MESSAGE_SIZE];
	int count = 0;
	FILE *fp;

	/* Check they have residency, no point continuing if they dont... */
	if (!p->residency)
		return;

	/* Read in the smesses */
	oldstack = stack;
	strcpy(name, p->name);
	lower_case(name);
	sprintf(oldstack, "files/smess/%s", p->name);
	stack = oldstack;
	if ((fp = fopen(stack, "r")) == NULL) {
		// No saved messages, I guess
		return;
	}

	TELLPLAYER(p, "\n");
	pstack_mid("Saved messages");
	*stack++ = '\0';
	TELLPLAYER(p, oldstack);
	stack = oldstack;
	while (fgets(name, MAX_NAME+1, fp)) {
		if (count++ > 0)
			TELLPLAYER(p, "\n");

		name[strlen(name)-1] = '\0';
		fgets(date, 50, fp); /* magic number, just needs to be big enough to pull out the time */
		date[strlen(date)-1] = '\0';
		fgets(message, MAX_MESSAGE_SIZE+1, fp);
		message[strlen(message)-1] = '\0';
		TELLPLAYER(p, "Message from %s, at %s:\n%s\n", name, date, message);
	}
	TELLPLAYER(p, "%s", LINE);

	fclose(fp);

	smess_clear(p->name);
}


/* function to clear any saved messages for a user
 *   used by smess_read and when a player file is removed
 */
void smess_clear(char *user) {
	char *oldstack;

	oldstack = stack;
	sprintf(oldstack, "files/smess/%s", user);
	stack = oldstack;
	unlink(stack);
}



/********************/
/*** Version code ***/
/********************/

void smess_version(void) {
  stack += sprintf(stack, " -=*> Smess v1.1 (by radiac) installed\n");
}

