/*
 * Playground+ - tagg.c
 * Vanilla Tag v1.1 (by Radiac)
 * ---------------------------------------------------------------------------
 */

/* headers */

#include <stdlib.h>

#include "include/config.h"
#include "include/player.h"
#include "include/proto.h"

/* the game */

void tagg(player * p, char *str)
{
  player *p2;
  player *scan;
  if (!*str) {
    /* No string passed. Try and start a new game */
    if (p->tagged != 0) {
      TELLPLAYER(p, " But you are already it!\n");
      return;
    }
    if (!p->residency) {
      TELLPLAYER(p, " Sorry, you're not a resident, so you can't play!\n");
      return;
    }
    for (scan = flatlist_start; scan; scan = scan->flat_next)
      if (p == scan) && (!(scan->misc_flags & NO_TAG)))
        TELLPLAYER(scan, " %s declares himself to be it!\n", p->name);

    TELLPLAYER(p, " You declare yourself it!\n");
    /* Set the tagged flag to 2 so they don't get a score when they tag someone */
    p->tagged = 2;

  } else {
    /* String has been passed */
    if (!strcmp(str,"who")) {
      /* They want to know who's it */
      int foundflag = 0;

      TELLPLAYER(p, "---------- [ Name ] ------------ [ Score ] ------- [ Location ] -----------\n");

      for (scan = flatlist_start; scan; scan = scan->flat_next) {
        if (scan->tagged != 0) {
          foundflag = 1;
          TELLPLAYER (p, "           %-18s    %-5d             ", scan->lower_name, scan->tag_score);
          if ((!strcmp(scan->location->owner->lower_name, SYS_ROOM_OWNER) || !strcmp(scan->location->owner->lower_name, "system"))) {
            if (!strcmp(scan->location->id, "room"))
              TELLPLAYER (p, "main");
            else
              TELLPLAYER (p, "%s", scan->location->id);
          } else if ((scan->custom_flags & HIDING) && (!(p->saved_residency & ADMIN))) {
            TELLPLAYER (p, "*Hiding*");
          } else if (!strcmp(scan->location->owner->lower_name, scan->lower_name)) {
            TELLPLAYER (p, "Home");
          } else {
            TELLPLAYER (p, "%s's", scan->location->owner->lower_name);
          }
          TELLPLAYER (p, "\n");
        }
      }

      if (!foundflag)
        TELLPLAYER (p, "    Nobody is it.\n");

      TELLPLAYER(p, "---------------------------------------------------------------------------\n");

    } else if (!strcmp(str,"version")) {
      TELLPLAYER(p,"\n -=> Vanilla Tag, v1.1 (by Radiac)\n -=> http://radiac.net/pgplus\n");

    } else if (!strcmp(str,"on")) {
      if (p->misc_flags & NO_TAG)
        p->misc_flags -= NO_TAG;
      TELLPLAYER(p, " You can be tagged.\n");

    } else if (!strcmp(str,"off")) {
      if (!(p->misc_flags & NO_TAG))
        p->misc_flags += NO_TAG;
      TELLPLAYER(p, " You can't be tagged.\n");

    } else if (!strcmp(str,"cancel")) {
      if (p->tagged == 0) {
        TELLPLAYER(p, " But you`re not it!\n");
        return;
      }
      p->tagged = 0;
      TELLPLAYER(p, " You cancel your tig game.\n");

    } else {

      if (p->tagged == 0) {
        TELLPLAYER(p, " But you`re not it!\n");
        return;
      }

      p2 = find_player_global(str);
      if (!p2) {
        /* p2 is not a player, or is at least not logged on. p is informed automatically */
        return;
      }

      if (!p2->residency) {
        TELLPLAYER(p, " Sorry, they're not a resident, so they can't play.\n");
        return;
      }

      if ((strcmp(p->location->owner->lower_name, p2->location->owner->lower_name)) || (strcmp(p->location->id, p2->location->id)))
      {
        TELLPLAYER(p, " You can't tag %s; they're not even in the same room!\n", full_name(p2));
        return;
      }

      if ((p2->residency & ROBOT_PRIV) || (p2->misc_flags & NO_TAG))
      {
        TELLPLAYER(p, " %s doesn't want to play.\n", full_name(p2));
        return;
      }

      if (p == p2)
      {
        TELLPLAYER(p, " You can't tag yourself!\n");
	return;
      }

      /* They're tagable */
      for (scan = flatlist_start; scan; scan = scan->flat_next)
        if ((strcmp(scan->name,p->name)) && (strcmp(scan->name,p2->name)) && (!(scan->misc_flags & NO_TAG)))
          TELLPLAYER(scan, " %s ^cTAG^Ns %s\n", p->name, p2->name);

      if (p->tagged == 1)
        p->tag_score += 30;
      if (p->tagged > 15000)
        p->tag_score = 15000;

      TELLPLAYER(p, " You ^cTAG^N %s!\n", full_name(p2));
      TELLPLAYER(p2, " You were ^cTAG^Nged by %s! You are now it!\n", full_name(p));
      p->tagged = 0;
      p2->tagged = 1;
    }
  }
}
